/* Problem URL: https://codeforces.com/edu/course/2/lesson/5/3/practice/contest/280799/problem/B */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    if (n > 1) {
        n = 1 << (32 - __builtin_clz(n - 1));
    }

    vi seg(n * 2);
    vi lazy(n * 2);

    auto propagate = [&](int i, int l, int r) {
        if (lazy[i] == 0) {
            return;
        }

        lazy[i] = 0;

        if (i >= n) {
            seg[i] ^= 1;
            return;
        }

        lazy[i * 2] ^= 1;
        lazy[i * 2 + 1] ^= 1;

        seg[i] = (r - l + 1) - seg[i];
    };

    function<void(int, int, int, int, int)> update = [&](int i, int l, int r, int tl, int tr) {
        propagate(i, l, r);

        if (l > tr || r < tl) {
            return;
        }

        if (l >= tl && r <= tr) {
            lazy[i] = 1;
            propagate(i, l, r);
            return;
        }

        int mid = (l + r) >> 1;

        update(i * 2, l, mid, tl, tr);
        update(i * 2 + 1, mid + 1, r, tl, tr);

        seg[i] = seg[i * 2] + seg[i * 2 + 1];
    };

    function<int(int, int, int, int)> search = [&](int i, int l, int r, int k) {
        propagate(i, l, r);
        if (i >= n) {
            return i - n;
        }

        int mid = (l + r) >> 1;

        propagate(i * 2, l, mid);
        if (seg[i * 2] < k) {
            return search(i * 2 + 1, mid + 1, r, k - seg[i * 2]);
        }

        return search(i * 2, l, mid, k);
    };

    while (m--) {
        int op;
        cin >> op;

        if (op == 1) {
            int l, r;
            cin >> l >> r;

            update(1, 0, n - 1, l, r - 1);
            continue;
        }

        int k;
        cin >> k;

        cout << search(1, 0, n - 1, k + 1) << '\n';
    }
}
